Overview | Package | Class | Tree | Deprecated | Index | Help
| ContactCenters V. 0.9.9.
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## umontreal.iro.lecuyer.contactcenters.msk.stat
Interface StatPeriod

All Superinterfaces:
  AWTPeriod

All Known Subinterfaces:
  SimLogic

All Known Implementing Classes:
  BatchMeansLogic, RepLogic

    public interface StatPeriod

extends AWTPeriod

Represents an object capable of assigning a statistical period to any observed call. An object implementing this interface is used by `CallCenterMeasureManager` and other associated observers to separate calls in periods.

Note that the values returned by `getNumPeriodsForCounters()`, `getNumPeriodsForCountersAwt()`, and `needsSlidingWindows()` should never change from call to call, for a given object implementing this interface.

Method Summary
`int` | `getNumPeriodsForCounters()` Returns the number of periods in usual matrices of counters updated throughout the simulation.
`int` | `getNumPeriodsForCountersAwt()` Similar to `getNumPeriodsForCounters()`, for matrices of counters using acceptable waiting times.
`int` | `getStatPeriod()` Returns the default statistical period.
`int` | `getStatPeriod(Contact contact)` Returns the statistical period of a contact `contact`.
`int` | `getStatPeriodAwt(Contact contact)` Similar to `getStatPeriod(Contact)`, for a statistic using an acceptable waiting time.
`boolean` | `needsSlidingWindows()` Determines if sliding windows are needed by statistical counters using an object implementing this interface to get the statistical periods of calls.
`boolean` | `needsStatForPeriodSegmentsAwt()` Determines if statistics for segments regrouping main periods are collected for measure types using acceptable waiting times.

Methods inherited from interface umontreal.iro.lecuyer.contactcenters.msk.stat.AWTPeriod
`getAwtPeriod, getGlobalAwtPeriod`

Method Detail

### getNumPeriodsForCounters

    int getNumPeriodsForCounters()

  Returns the number of periods in usual matrices of counters updated throughout the simulation. Usually, this corresponds to P + 2, the total number of periods, but this returns 1 for a steady-state simulation over a single period.

  Returns:
    the number of periods for matrices of counters.

### getNumPeriodsForCountersAwt

    int getNumPeriodsForCountersAwt()

  Similar to `getNumPeriodsForCounters()`, for matrices of counters using acceptable waiting times. This usually returns P', the total number of segments regrouping main periods. But this returns 1 for a steady-state simulation over a single period.

  Returns:
    the number of periods for matrices of counters.

### getStatPeriod

    int getStatPeriod(Contact contact)

  Returns the statistical period of a contact `contact`. If a negative index is returned for a given contact, this contact is not counted in statistics. This often corresponds to the period during which the contact arrives, but this always returns 0 for steady-state simulations.

### getStatPeriodAwt

    int getStatPeriodAwt(Contact contact)

  Similar to `getStatPeriod(Contact)`, for a statistic using an acceptable waiting time. If a negative index is returned for a given contact, this contact is not counted in statistics. Often, this returns `getStatPeriod(Contact)` minus 1.

### needsStatForPeriodSegmentsAwt

    boolean needsStatForPeriodSegmentsAwt()

  Determines if statistics for segments regrouping main periods are collected for measure types using acceptable waiting times. Usually, statistics are collected for each main period, and sums are computed at a later time if needed. However, statistics based on acceptable waiting times cannot be summed, because the AWT may change from periods to periods in general. This method thus indicates if observers must collect observations for groups of main periods in addition to the statistical periods of calls.

### getStatPeriod

    int getStatPeriod()

  Returns the default statistical period. This usually corresponds to the current period.

### needsSlidingWindows

    boolean needsSlidingWindows()

  Determines if sliding windows are needed by statistical counters using an object implementing this interface to get the statistical periods of calls. Usually, the period index returned by `getStatPeriod(Contact)` is never greater than the integer returned by `getNumPeriodsForCounters()`, and the same relationship holds for `getStatPeriodAwt(Contact)` and `getNumPeriodsForCountersAwt()`. However, this assumption can be violated if one needs to get real-time statistics concerning the last observed periods. In such cases, matrices of counters need to be implemented using sliding windows: when the index a statistical period becomes higher than the number of stored periods, the first periods are discarded. This method determines if such sliding windows are needed.

Overview | Package | Class | Tree | Deprecated | Index | Help
| ContactCenters V. 0.9.9.
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

To submit a bug or ask questions, send an e-mail to Richard Simard.